/*
 * CConstraint.h
 *
 *  Created on: 6 mai 2010
 *      Author: bboulay
 */

#ifndef CCONSTRAINT_H_
#define CCONSTRAINT_H_

#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <sstream>
//#include "CSAccessor.h"
#include "CSAgent.h"
#include "CParserTool.h"
//#include "CSOperator.h"
//#include "CSOperatorAgent.h"
//#include "CSBasicOperator.h"
//#include "CSAllOperators.h"
#include "CSOperatorInterfaceAbstract.h"

class CConstraint {
public:
	CConstraint();
	virtual ~CConstraint();

	void read(std::string i_block);
	void readAttributes(std::string i_block);

	void fillConstraintsConstants(std::map<std::string, double> i_allConstants);
	void classifyConstraints(std::vector<std::string> i_code);

	void print();
	bool checkOperator(std::map<std::string, CSOperatorInterfaceAbstract*> i_allOperators);

	std::tr1::shared_ptr<CSBool> verify(std::map<std::string,std::tr1::shared_ptr<CSAgent> > i_agent);

	std::tr1::shared_ptr<CSBasicType> check(std::map<std::string, std::tr1::shared_ptr<CSAgent> > i_agent);

	void rewriteAgentOperator(std::map<std::string, std::string> l_po);

public:
	CSOperatorInterfaceAbstract* m_operatorClass;
	std::string m_operator;
	std::string m_value; //if m_operator == "NULL"
	double m_dvalue; //value of the constant
	bool m_constant;
	bool m_temporal;
	std::string m_attribute; //if m_operator == "->"
	std::vector<CConstraint*> m_predicats;
	double m_confidence;

	//name of operator, operator itself
	static std::map<std::string, CSOperatorInterfaceAbstract*> m_allOperators;

};

#endif /* CCONSTRAINT_H_ */
