#ifndef SUPCOMPOSERNODEPROCESSACQUISITION_H
#define SUPCOMPOSERNODEPROCESSACQUISITION_H

#include "supComposerExport.h"

#include <dtkComposer/dtkComposerNodeLeafProcess.h>

#include <QtCore>

class supComposerNodeProcessAcquisitionPrivate;

class SUPCOMPOSER_EXPORT supComposerNodeProcessAcquisition : public QObject, public dtkComposerNodeLeafProcess
{
    Q_OBJECT

public:
     supComposerNodeProcessAcquisition(void);
    ~supComposerNodeProcessAcquisition(void);

public:
    void run(void);

public:
    inline QString type(void) {
        return "supProcessAcquisition";
    }

    inline QString titleHint(void) {
        return "Acquisition";
    }

    inline QString inputLabelHint(int port) {
        switch(port) {
        case 0:
            return "stream";
        default:
            return dtkComposerNodeLeafProcess::inputLabelHint(port);
        };
    }

    inline QString outputLabelHint(int port) {
        switch(port) {
        case 0:
            return "image";
        case 1:
            return "depth";
        default:
            return dtkComposerNodeLeafProcess::outputLabelHint(port);
        };
    }

    inline bool isAbstractProcess(void) const {
        return true;
    }

    inline QString abstractProcessType(void) const {
        return "supAbstractProcessAcquisition";
    }

private:
    supComposerNodeProcessAcquisitionPrivate *d;
};

#endif
