#ifndef CONTEXTELEMENT
#define CONTEXTELEMENT
#include<opencv2/core/core.hpp>


/*
//Include the shapes above to the union clause in the contextObject struct below.

struct contextObject_t{

         std::string semantic;
         std::string name;
         double height;
         std::string shape;

         union shape_t{
         	//Add your shapes here.
             circle_t *circle;
             polygon_t *polygon;
         }shape_o;

     };
*/
#include<opencv2/core/core.hpp>
#include<iostream>
#include<string>
#include<time.h>
#include<list>

//using namespace cv;
using namespace std;
//typedef std::list <cv::Point3d> vertexList;

//Define diffrent structures for shapes required here
struct circle_t{
         double radius;
         cv::Point3d center;
     };

struct polygon_t{
         std::list <cv::Point3d> vertexList;
         int isClosed;
     };
struct cube_t{
         std::list <cv::Point3d> vertexList;
         int isClosed;
     };
/*
union shape_t{
   //Add your shapes here.
    struct circle_t *circle;
    struct polygon_t *polygon;
}elementShape;
*/

class ContextElement{
	private:
		string semantic;
		string name;
		double height;
		string shape;

        //Add the structures defined above here.
        struct circle_t     circle;
        struct polygon_t    polygon;
        struct cube_t       cube;

    public:
        //constructor
        ContextElement(std::string i_name, std::string i_semantic, std::string i_shape, double i_height)
        {
            this->name      = i_name;
            this->semantic  = i_semantic;
            this->height    = i_height;
            this->shape     = i_shape;
        }
        //Copy Constructor
        ContextElement(const ContextElement &obj)
        {
            name = obj.name;
            semantic = obj.semantic;
            height = obj.height;
            shape = obj.shape;

            circle.center = obj.circle.center;
            circle.radius = obj.circle.radius;

            polygon.isClosed = obj.polygon.isClosed;

            polygon.vertexList = obj.polygon.vertexList;

            cube.isClosed = obj.cube.isClosed;
            cube.vertexList = obj.cube.vertexList;
        }

//For structures defined above
        void setPolygon(struct polygon_t& i_polygon)
        {
            //cout<<"printing"<<i_polygon->isClosed<<endl;
            this->polygon.isClosed = i_polygon.isClosed;
            this->polygon.vertexList = i_polygon.vertexList;
        }
        void setCircle(struct circle_t& i_circle)
        {
            this->circle.radius = i_circle.radius;
            this->circle.center = i_circle.center;
        }
        void setCube(struct cube_t& i_cube)
        {
            this->cube.isClosed = i_cube.isClosed;
            this->cube.vertexList = i_cube.vertexList;
        }

//Accessor Methods
double getHeight() const
{
    return height;
}
string getName() const
{
    return name;
}

string getSemantic() const
{
    return semantic;
}

string getShape() const
{
    return shape;
}
int getisClosed() const
{
    return polygon.isClosed;
}
std::list <cv::Point3d> getVertexList(void)
{
    return polygon.vertexList;
}
int getCubeisClosed() const
{
    return cube.isClosed;
}
std::list <cv::Point3d> getCubeVertexList(void)
{
    return cube.vertexList;
}
double getRadius()
{
    return circle.radius;
}
cv::Point3d getCenter()
{
    return circle.center;
}			
//Mutator Methods

void setHeight(double i_height)
{
    this->height = i_height;
}

void setName(string i_name)
{
    this->name = i_name;
}

void setSemantic(string i_semantic)
{
    this->semantic = i_semantic;
}

void setShape(string i_shape)
{
    this->shape = i_shape;
}

//Other Methods
void displayObject()
{
	cout<<"Semantic: "<<getSemantic()<<endl;
	cout<<"Name: "<<getName()<<endl;
	cout<<"Shape: "<<getShape()<<endl;
	cout<<"Height: "<<getHeight()<<endl;

    string shape = getShape();

    if (shape =="circle")
    {
        cout<<"Radius: "<<getRadius()<<endl;
        cout<<"Center: "<<"x: "<<getCenter().x<<" y: "<<getCenter().y<<" z: "<<getCenter().z<<endl;
    }
    else if (shape=="polygon")
    {
        cout<<"isClosed: "<<getisClosed()<<endl;

        std::list <cv::Point3d> vertexList = getVertexList();
        cout<<"No. of Vertices: "<<vertexList.size()<<endl;
        cout<<"Vertices Coordinates:"<<endl;
        list<cv::Point3d>::iterator iitt = vertexList.begin();
        for(iitt = vertexList.begin(); iitt != vertexList.end(); iitt++)
            cout<<"x: "<<(*iitt).x<<" y: "<<(*iitt).y<<" z: "<<(*iitt).z<<endl;
    }
    else if (shape=="cube")
    {
        cout<<"isClosed: "<<getCubeisClosed()<<endl;

        std::list <cv::Point3d> vertexList = getCubeVertexList();
        cout<<"No. of Vertices: "<<vertexList.size()<<endl;
        cout<<"Vertices Coordinates:"<<endl;
        list<cv::Point3d>::iterator iitt = vertexList.begin();
        for(iitt = vertexList.begin(); iitt != vertexList.end(); iitt++)
            cout<<"x: "<<(*iitt).x<<" y: "<<(*iitt).y<<" z: "<<(*iitt).z<<endl;
    }
    else
    {
        cout<<"Invalid shape!"<<endl<<endl;
    }
}
};
#endif
