#ifndef SKELETON_STRUCTURE
#define SKELETON_STRUCTURE 1

#include <opencv2/core/core.hpp>

struct BodyPlane { //ax + by + cz + d = 0, z = depth
    double a, b, c, d;
    BodyPlane () : a(0), b(0), c(0), d(0) {};
};



struct Position2d3d {
    cv::Point2i pos2d;
    cv::Point3f pos3d;
    Position2d3d() {
        pos2d.x = pos2d.y = -1;
        pos3d.x = pos3d.y = pos3d.z = 0;
    }
};

struct SkeletonStructure {
    Position2d3d headCenterPos, leftShoulder, rightShoulder;
    BodyPlane bodyPlane;
    SkeletonStructure() : headCenterPos(), leftShoulder(), rightShoulder(), bodyPlane() {
    };
};

#endif
