#ifndef SUPABSTRACTPROCESSDATAFLOWWRITER_P_H
#define SUPABSTRACTPROCESSDATAFLOWWRITER_P_H

#include "supAbstractProcess_p.h"
#include "supAbstractProcessDataWriter.h"
#include "supAbstractData.h"
#include <QFile>
#include <QDir>
#include <QList>
#include <QDomElement>
#include <QDomDocument>

class supAbstractProcessDataFlowWriter;

////////////////////////////////////////////////////
// supAbstractProcessDataFlowWriterPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractProcessDataFlowWriterPrivate : public supAbstractProcessPrivate
{
public:
    supAbstractProcessDataFlowWriterPrivate(supAbstractProcessDataFlowWriter *q = 0) : supAbstractProcessPrivate(q) {
        m_dataWriter = new supAbstractProcessDataWriter();
        m_xmlDoc = QDomDocument();


    }
    supAbstractProcessDataFlowWriterPrivate(const supAbstractProcessDataFlowWriterPrivate& other) : supAbstractProcessPrivate(other) {
        m_file.setFileName(other.m_file.fileName());
        m_dataFlow = other.m_dataFlow;
        m_dataWriter = other.m_dataWriter;
        m_xmlDoc = other.m_xmlDoc;
    }

public:
    virtual ~supAbstractProcessDataFlowWriterPrivate(void) {
        if (m_dataWriter != NULL) {
            delete m_dataWriter;
            m_dataWriter = NULL;
        }

    }

public:
    // ...
    QFile m_file;
    // ...
    QList< QSharedPointer< supAbstractData > > m_dataFlow;
    // ...
    supAbstractProcessDataWriter* m_dataWriter;

    // ...
    QDomDocument m_xmlDoc;
};

////////////////////////////////////////////////////
// supAbstractProcessDataFlowWriter protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractProcessDataFlowWriter, supAbstractProcess);

#endif
