#ifndef SUPVIEW_P_H
#define SUPVIEW_P_H

#include <dtkCore/dtkAbstractView_p.h>


class QGraphicsScene;
class QGraphicsView;

class QGraphicsPixmapItem;
class QGraphicsItemGroup;

class supView;

class supViewPrivate : public dtkAbstractViewPrivate
{
public:
    supViewPrivate(supView *q = 0) : dtkAbstractViewPrivate(q), image(new QGraphicsPixmapItem), segmentation( new QGraphicsPixmapItem)
    {
        view.setRenderHint(QPainter::Antialiasing, true);
        view.setScene(&scene);

        scene.addItem(image);
        scene.addItem(segmentation);
    }
    supViewPrivate(const supViewPrivate& other) : dtkAbstractViewPrivate(other), image(other.image), segmentation(other.segmentation), display(other.display)
    {
        view.setRenderHint(QPainter::Antialiasing, true);
        view.setScene(&scene);

        scene.addItem(image);
        scene.addItem(segmentation);
    }

public:
    virtual ~supViewPrivate(void)
    {
        scene.clear();
    }

public:
    QGraphicsScene scene;
    QGraphicsView  view;

    QGraphicsPixmapItem* image;
    QGraphicsPixmapItem* segmentation;
    QList< QGraphicsItem* > blobs;
    QList< QGraphicsItem* > pos;

    QSharedPointer< supDataImage > display;
};

DTK_IMPLEMENT_PRIVATE(supView, dtkAbstractView)

#endif

